import { SpreadsheetWorksheet } from './SpreadsheetWorksheet';
import { SpreadsheetRow } from './SpreadsheetRow';
import { SpreadsheetCell } from './SpreadsheetCell';
import { SpreadsheetInfo, GetCellsOptions, ServiceAccountParams, AddWorksheetOptions, GetRowOptions, IndexSignature } from '../types';
export declare class GoogleSpreadsheet {
    private visibility;
    private projection;
    private auth_mode;
    private jwt_client;
    private auth_client;
    private readonly ss_key;
    private info;
    constructor(ss_key: string);
    useServiceAccountAuth: (creds: ServiceAccountParams) => Promise<void>;
    private renewJwtAuth;
    private isAuthActive;
    private ensureAuthIsUpToDate;
    makeFeedRequest: (url_params: any, method: any, query_or_data: any) => Promise<{
        data: any;
        xml: any;
    }>;
    getInfo: () => Promise<SpreadsheetInfo>;
    addWorksheet: (opts?: Partial<AddWorksheetOptions>) => Promise<SpreadsheetWorksheet>;
    removeWorksheet: (sheet_id: number | SpreadsheetWorksheet) => Promise<{
        data: any;
        xml: any;
    }>;
    getRows: (worksheet_id: number, opts?: Partial<GetRowOptions>) => Promise<SpreadsheetRow[]>;
    addRow: (worksheet_id: number, rowData: IndexSignature<string | number>) => Promise<SpreadsheetRow>;
    getCells: (worksheet_id: number, opts?: Partial<GetCellsOptions>) => Promise<SpreadsheetCell[]>;
}
//# sourceMappingURL=GoogleSpreadsheet.d.ts.map