"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = __importDefault(require("lodash"));
var gal = __importStar(require("google-auth-library"));
var utils_1 = require("./utils");
var SpreadsheetWorksheet_1 = require("./SpreadsheetWorksheet");
var SpreadsheetRow_1 = require("./SpreadsheetRow");
var SpreadsheetCell_1 = require("./SpreadsheetCell");
var GOOGLE_FEED_URL = 'https://spreadsheets.google.com/feeds/';
var GOOGLE_AUTH_SCOPE = ['https://spreadsheets.google.com/feeds'];
var REQUIRE_AUTH_MESSAGE = 'You must authenticate to modify sheet data';
var GoogleSpreadsheet = /** @class */ (function () {
    function GoogleSpreadsheet(ss_key) {
        var _this = this;
        this.visibility = 'public';
        this.projection = 'values';
        this.auth_mode = 'anonymous';
        // -------------------  Authentication ---------------------
        this.useServiceAccountAuth = function (creds) { return __awaiter(_this, void 0, void 0, function () {
            var credentials;
            return __generator(this, function (_a) {
                if (typeof creds == 'string') {
                    creds = require(creds);
                }
                credentials = creds;
                this.jwt_client = new gal.JWT(credentials.client_email, undefined, credentials.private_key, GOOGLE_AUTH_SCOPE, undefined);
                return [2 /*return*/, this.renewJwtAuth()];
            });
        }); };
        this.renewJwtAuth = function () { return __awaiter(_this, void 0, void 0, function () {
            var token;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.auth_mode = 'jwt';
                        return [4 /*yield*/, this.jwt_client.authorize()];
                    case 1:
                        token = _a.sent();
                        this.auth_client = {
                            type: token.token_type,
                            value: token.access_token,
                            expires: token.expiry_date,
                        };
                        this.visibility = 'private';
                        this.projection = 'full';
                        return [2 /*return*/];
                }
            });
        }); };
        this.isAuthActive = function () {
            return !!_this.auth_client;
        };
        this.ensureAuthIsUpToDate = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (this.auth_mode != 'jwt') {
                    return [2 /*return*/];
                }
                if (this.auth_client && this.auth_client.expires > +new Date()) {
                    return [2 /*return*/];
                }
                return [2 /*return*/, this.renewJwtAuth()];
            });
        }); };
        // ---------------------- Auth end ------------------------
        // This method is used internally to make all requests
        this.makeFeedRequest = function (url_params, method, query_or_data) { return __awaiter(_this, void 0, void 0, function () {
            var url;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (typeof url_params == 'string') {
                            // used for edit / delete requests
                            url = url_params;
                        }
                        else if (Array.isArray(url_params)) {
                            //used for get and post requets
                            url_params.push(this.visibility, this.projection);
                            url = GOOGLE_FEED_URL + url_params.join('/');
                        }
                        else {
                            throw Error('Internal sheets error. Attempted to make a request without url params.');
                        }
                        return [4 /*yield*/, this.ensureAuthIsUpToDate()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, utils_1.makeRequest(method, url, query_or_data, this.auth_client)];
                }
            });
        }); };
        // public API methods
        this.getInfo = function () { return __awaiter(_this, void 0, void 0, function () {
            var data, ss_data, worksheets;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.makeFeedRequest(['worksheets', this.ss_key], 'GET', null)];
                    case 1:
                        data = (_a.sent()).data;
                        if (data === true) {
                            throw Error('No response to getInfo call');
                        }
                        ss_data = {
                            id: data.id,
                            title: data.title,
                            updated: data.updated,
                            author: data.author,
                            worksheets: [],
                        };
                        worksheets = utils_1.forceArray(data.entry);
                        worksheets.forEach(function (ws_data) {
                            ss_data.worksheets.push(new SpreadsheetWorksheet_1.SpreadsheetWorksheet(_this, ws_data));
                        });
                        this.info = ss_data;
                        return [2 /*return*/, ss_data];
                }
            });
        }); };
        // NOTE: worksheet IDs start at 1
        this.addWorksheet = function (opts) {
            if (opts === void 0) { opts = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var fullOptions, data_xml, data, sheet;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.isAuthActive()) {
                                throw Error(REQUIRE_AUTH_MESSAGE);
                            }
                            fullOptions = __assign({ 
                                //Defaults
                                title: 'Worksheet ' + +new Date(), rowCount: 50, colCount: 20 }, opts);
                            // if column headers are set, make sure the sheet is big enough for them
                            if (fullOptions.headers &&
                                fullOptions.headers.length > fullOptions.colCount) {
                                fullOptions.colCount = fullOptions.headers.length;
                            }
                            data_xml = '<entry xmlns="http://www.w3.org/2005/Atom" xmlns:gs="http://schemas.google.com/spreadsheets/2006"><title>' +
                                fullOptions.title +
                                '</title><gs:rowCount>' +
                                fullOptions.rowCount +
                                '</gs:rowCount><gs:colCount>' +
                                fullOptions.colCount +
                                '</gs:colCount></entry>';
                            return [4 /*yield*/, this.makeFeedRequest(['worksheets', this.ss_key], 'POST', data_xml)];
                        case 1:
                            data = (_a.sent()).data;
                            sheet = new SpreadsheetWorksheet_1.SpreadsheetWorksheet(this, data);
                            return [4 /*yield*/, sheet.setHeaderRow(fullOptions.headers)];
                        case 2:
                            _a.sent();
                            return [2 /*return*/, sheet];
                    }
                });
            });
        };
        this.removeWorksheet = function (sheet_id) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (!this.isAuthActive()) {
                    throw Error(REQUIRE_AUTH_MESSAGE);
                }
                if (sheet_id instanceof SpreadsheetWorksheet_1.SpreadsheetWorksheet) {
                    return [2 /*return*/, sheet_id.del()];
                }
                return [2 /*return*/, this.makeFeedRequest(GOOGLE_FEED_URL +
                        'worksheets/' +
                        this.ss_key +
                        '/private/full/' +
                        sheet_id, 'DELETE', null)];
            });
        }); };
        this.getRows = function (worksheet_id, opts) {
            if (opts === void 0) { opts = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var query, _a, data, xml, entries_xml, feed_props, feed_props_str, rows, entries;
                var _this = this;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            query = lodash_1.default.omitBy({
                                'start-index': opts.offset,
                                'max-results': opts.limit,
                                orderby: opts.orderby,
                                reverse: opts.reverse,
                                sq: opts.query,
                            }, lodash_1.default.isUndefined);
                            return [4 /*yield*/, this.makeFeedRequest(['list', this.ss_key, worksheet_id], 'GET', query)];
                        case 1:
                            _a = _b.sent(), data = _a.data, xml = _a.xml;
                            entries_xml = xml.match(/<entry[^>]*>([\s\S]*?)<\/entry>/g);
                            feed_props = lodash_1.default.clone(data.$);
                            delete feed_props['gd:etag'];
                            feed_props_str = lodash_1.default.reduce(feed_props, function (str, val, key) {
                                return str + key + "='" + val + "' ";
                            }, '');
                            entries_xml = lodash_1.default.map(entries_xml, function (xml) {
                                return xml.replace('<entry ', '<entry ' + feed_props_str);
                            });
                            rows = [];
                            entries = utils_1.forceArray(data.entry);
                            entries.forEach(function (row_data, i) {
                                rows.push(new SpreadsheetRow_1.SpreadsheetRow(_this, row_data, entries_xml[i++]));
                            });
                            return [2 /*return*/, rows];
                    }
                });
            });
        };
        this.addRow = function (worksheet_id, rowData) { return __awaiter(_this, void 0, void 0, function () {
            var data_xml, _a, data, new_xml, entries_xml;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        data_xml = '<entry xmlns="http://www.w3.org/2005/Atom" xmlns:gsx="http://schemas.google.com/spreadsheets/2006/extended">' +
                            '\n';
                        Object.keys(rowData).forEach(function (key) {
                            if (key != 'id' &&
                                key != 'title' &&
                                key != 'content' &&
                                key != '_links') {
                                data_xml +=
                                    '<gsx:' +
                                        utils_1.xmlSafeColumnName(key) +
                                        '>' +
                                        utils_1.xmlSafeValue(rowData[key]) +
                                        '</gsx:' +
                                        utils_1.xmlSafeColumnName(key) +
                                        '>' +
                                        '\n';
                            }
                        });
                        data_xml += '</entry>';
                        return [4 /*yield*/, this.makeFeedRequest(['list', this.ss_key, worksheet_id], 'POST', data_xml)];
                    case 1:
                        _a = _b.sent(), data = _a.data, new_xml = _a.xml;
                        entries_xml = new_xml.match(/<entry[^>]*>([\s\S]*?)<\/entry>/g);
                        return [2 /*return*/, new SpreadsheetRow_1.SpreadsheetRow(this, data, entries_xml[0])];
                }
            });
        }); };
        this.getCells = function (worksheet_id, opts) {
            if (opts === void 0) { opts = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var data, cells, entries;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.makeFeedRequest(['cells', this.ss_key, worksheet_id], 'GET', opts)];
                        case 1:
                            data = (_a.sent()).data;
                            cells = [];
                            entries = utils_1.forceArray(data['entry']);
                            entries.forEach(function (cell_data) {
                                cells.push(new SpreadsheetCell_1.SpreadsheetCell(_this, worksheet_id, cell_data));
                            });
                            return [2 /*return*/, cells];
                    }
                });
            });
        };
        if (!ss_key) {
            throw new Error('Spreadsheet key not provided.');
        }
        this.ss_key = ss_key;
    }
    return GoogleSpreadsheet;
}());
exports.GoogleSpreadsheet = GoogleSpreadsheet;
//# sourceMappingURL=GoogleSpreadsheet.js.map