import { GoogleSpreadsheet } from './GoogleSpreadsheet';
import { SpreadsheetCellData } from '../types';
export declare class SpreadsheetCell {
    readonly row: number;
    readonly col: number;
    private readonly id;
    private readonly _links;
    private batchId;
    private _formula;
    private _value;
    private spreadsheet;
    private worksheet_id;
    constructor(spreadsheet: GoogleSpreadsheet, worksheet_id: number, data: SpreadsheetCellData);
    /**
     * Sets value and saves
     * @param {string} new_value
     * @returns {Promise<void>}
     */
    setValue: (new_value: string | number) => Promise<void>;
    /**
     * Saves cell. Mutates cell if e.g. a formula has been entered-
     * @returns {Promise<void>}
     */
    save: () => Promise<void>;
    /**
     * Clears cell
     * @returns {Promise<Promise<void>>}
     */
    del: () => Promise<void>;
    val: (val: string | number) => void;
    /**
    * Set the value. If you want to clear, either use the empty string or use the .del method
    * @param {string | number} val
    */
    value: string;
    formula: string | undefined;
    readonly numericValue: number;
    private updateValuesFromResponseData;
    private _clearValue;
    private valueForSave;
}
//# sourceMappingURL=SpreadsheetCell.d.ts.map