import { GoogleSpreadsheet } from './GoogleSpreadsheet';
import { WorksheetData } from '../types';
import { SpreadsheetRow } from './SpreadsheetRow';
import { SpreadsheetCell } from './SpreadsheetCell';
/**
 * TODO: Describe file contents
 */
interface WorksheetInfo {
    title: string;
    rowCount: number;
    colCount: number;
}
export declare class SpreadsheetWorksheet {
    private spreadsheet;
    url: string;
    readonly id: number;
    title: string;
    rowCount: number;
    colCount: number;
    private readonly _links;
    constructor(spreadsheet: GoogleSpreadsheet, data: WorksheetData);
    private _setInfo;
    resize: (opts?: Partial<WorksheetInfo>) => Promise<void>;
    setTitle: (title: string) => Promise<void>;
    clear: () => Promise<void>;
    getRows: (opts?: any) => Promise<SpreadsheetRow[]>;
    getCells: (opts?: any) => Promise<SpreadsheetCell[]>;
    addRow: (data: any) => Promise<SpreadsheetRow>;
    bulkUpdateCells: (cells: any[]) => Promise<void>;
    del: () => Promise<{
        data: any;
        xml: any;
    }>;
    setHeaderRow: (values: any) => Promise<void>;
}
export {};
//# sourceMappingURL=SpreadsheetWorksheet.d.ts.map