"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("./utils");
var _ = __importStar(require("lodash"));
var SpreadsheetWorksheet = /** @class */ (function () {
    function SpreadsheetWorksheet(spreadsheet, data) {
        var _this = this;
        this._setInfo = function (opts) {
            if (opts === void 0) { opts = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var xml, response;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            xml = "<entry xmlns=\"http://www.w3.org/2005/Atom\" xmlns:gs=\"http://schemas.google.com/spreadsheets/2006\"><title>" + (opts.title ||
                                this.title) + "</title><gs:rowCount>" + (opts.rowCount ||
                                this.rowCount) + "</gs:rowCount><gs:colCount>" + (opts.colCount ||
                                this.colCount) + "</gs:colCount></entry>";
                            return [4 /*yield*/, this.spreadsheet.makeFeedRequest(this['_links']['edit'], 'PUT', xml)];
                        case 1:
                            response = (_a.sent()).data;
                            this.title = response.title;
                            this.rowCount = parseInt(response['gs:rowCount']);
                            this.colCount = parseInt(response['gs:colCount']);
                            return [2 /*return*/];
                    }
                });
            });
        };
        this.resize = this._setInfo;
        this.setTitle = function (title) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this._setInfo({ title: title })];
            });
        }); };
        // just a convenience method to clear the whole sheet
        // resizes to 1 cell, clears the cell, and puts it back
        this.clear = function () { return __awaiter(_this, void 0, void 0, function () {
            var cols, rows, cells;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cols = this.colCount;
                        rows = this.colCount;
                        return [4 /*yield*/, this.resize({ rowCount: 1, colCount: 1 })];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.getCells()];
                    case 2:
                        cells = _a.sent();
                        return [4 /*yield*/, cells[0].setValue('')];
                    case 3:
                        _a.sent();
                        return [2 /*return*/, this.resize({ rowCount: rows, colCount: cols })];
                }
            });
        }); };
        this.getRows = function (opts) {
            if (opts === void 0) { opts = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.spreadsheet.getRows(this.id, opts)];
                });
            });
        };
        this.getCells = function (opts) {
            if (opts === void 0) { opts = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, this.spreadsheet.getCells(this.id, opts)];
                });
            });
        };
        this.addRow = function (data) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.spreadsheet.addRow(this.id, data)];
            });
        }); };
        this.bulkUpdateCells = function (cells) { return __awaiter(_this, void 0, void 0, function () {
            var entries, data_xml, data, cells_by_batch_id;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        entries = cells.map(function (cell) {
                            cell._needsSave = false;
                            return "<entry>\n        <batch:id>" + cell.batchId + "</batch:id>\n        <batch:operation type=\"update\"/>\n        <id>" + _this['_links']['cells'] + "/" + cell.batchId + "</id>\n        <link rel=\"edit\" type=\"application/atom+xml\"\n          href=\"" + cell._links.edit + "\"/>\n        <gs:cell row=\"" + cell.row + "\" col=\"" + cell.col + "\" inputValue=\"" + cell.valueForSave() + "\"/>\n      </entry>";
                        });
                        data_xml = "<feed xmlns=\"http://www.w3.org/2005/Atom\"\n      xmlns:batch=\"http://schemas.google.com/gdata/batch\"\n      xmlns:gs=\"http://schemas.google.com/spreadsheets/2006\">\n      <id>" + this['_links']['cells'] + "</id>\n      " + entries.join('\n') + "\n    </feed>";
                        return [4 /*yield*/, this.spreadsheet.makeFeedRequest(this['_links']['bulkcells'], 'POST', data_xml)];
                    case 1:
                        data = (_a.sent()).data;
                        cells_by_batch_id = _.keyBy(cells, 'batchId');
                        if (data.entry && data.entry.length) {
                            data.entry.forEach(function (cell_data) {
                                cells_by_batch_id[cell_data['batch:id']].updateValuesFromResponseData(cell_data);
                            });
                        }
                        return [2 /*return*/];
                }
            });
        }); };
        this.del = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.spreadsheet.makeFeedRequest(this['_links']['edit'], 'DELETE', null)];
            });
        }); };
        this.setHeaderRow = function (values) { return __awaiter(_this, void 0, void 0, function () {
            var cells;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!values) {
                            return [2 /*return*/];
                        }
                        if (values.length > this.colCount) {
                            throw Error('Sheet is not large enough to fit ' +
                                values.length +
                                ' columns. Resize the sheet first.');
                        }
                        return [4 /*yield*/, this.getCells({
                                'min-row': 1,
                                'max-row': 1,
                                'min-col': 1,
                                'max-col': this.colCount,
                                'return-empty': true,
                            })];
                    case 1:
                        cells = _a.sent();
                        _.each(cells, function (cell) {
                            cell.value = values[cell.col - 1] ? values[cell.col - 1] : '';
                        });
                        return [2 /*return*/, this.bulkUpdateCells(cells)];
                }
            });
        }); };
        var links;
        this.spreadsheet = spreadsheet;
        this.url = data.id;
        this.id = data.id.substring(data.id.lastIndexOf('/') + 1);
        this.title = data.title;
        this.rowCount = parseInt(data['gs:rowCount']);
        this.colCount = parseInt(data['gs:colCount']);
        this._links = [];
        links = utils_1.forceArray(data.link);
        links.forEach(function (link) {
            _this._links[link['$']['rel']] = link['$']['href'];
        });
        this._links['cells'] = this._links['http://schemas.google.com/spreadsheets/2006#cellsfeed'];
        this._links['bulkcells'] = this._links['cells'] + '/batch';
    }
    return SpreadsheetWorksheet;
}());
exports.SpreadsheetWorksheet = SpreadsheetWorksheet;
//# sourceMappingURL=SpreadsheetWorksheet.js.map