"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var axios_1 = __importDefault(require("axios"));
var querystring = __importStar(require("querystring"));
var util = __importStar(require("util"));
var xml2js_1 = __importDefault(require("xml2js"));
function forceArray(val) {
    if (Array.isArray(val))
        return val;
    if (!val)
        return [];
    return [val];
}
exports.forceArray = forceArray;
function xmlSafeValue(val) {
    if (val == null)
        return '';
    return String(val)
        .replace(/&/g, '&amp;')
        .replace(/</g, '&lt;')
        .replace(/>/g, '&gt;')
        .replace(/"/g, '&quot;')
        .replace(/\n/g, '&#10;')
        .replace(/\r/g, '&#13;');
}
exports.xmlSafeValue = xmlSafeValue;
function xmlSafeColumnName(val) {
    if (!val)
        return '';
    return String(val)
        .replace(/[\s_]+/g, '')
        .toLowerCase();
}
exports.xmlSafeColumnName = xmlSafeColumnName;
var xmlParser = new xml2js_1.default.Parser({
    // options carried over from older version of xml2js
    // might want to update how the code works, but for now this is fine
    explicitArray: false,
    explicitRoot: false,
});
exports.makeRequest = function (method, url, query_or_data, auth_client) { return __awaiter(_this, void 0, void 0, function () {
    var headers, query, response, err_1, promisifedParse, parseResult;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                headers = {};
                if (auth_client) {
                    //@ts-ignore
                    if (auth_client.type === 'Bearer') {
                        //@ts-ignore
                        headers['Authorization'] = 'Bearer ' + auth_client.value;
                    }
                    else {
                        headers['Authorization'] = 'GoogleLogin auth=' + auth_client;
                    }
                }
                headers['Gdata-Version'] = '3.0';
                if (method == 'POST' || method == 'PUT') {
                    headers['content-type'] = 'application/atom+xml';
                }
                if (method == 'PUT' || (method == 'POST' && url.indexOf('/batch') != -1)) {
                    headers['If-Match'] = '*';
                }
                if (method == 'GET' && query_or_data) {
                    query = '?' + querystring.stringify(query_or_data);
                    // replacements are needed for using structured queries on getRows
                    query = query.replace(/%3E/g, '>');
                    query = query.replace(/%3D/g, '=');
                    query = query.replace(/%3C/g, '<');
                    url += query;
                }
                _a.label = 1;
            case 1:
                _a.trys.push([1, 3, , 4]);
                return [4 /*yield*/, axios_1.default.request({
                        url: url,
                        method: method,
                        headers: headers,
                        data: method == 'POST' || method == 'PUT' ? query_or_data : null,
                        //The response is xml - we'll just grab it as text to avoid json parse errors
                        responseType: 'text',
                    })];
            case 2:
                response = _a.sent();
                return [3 /*break*/, 4];
            case 3:
                err_1 = _a.sent();
                if (err_1.response.status === 401) {
                    throw new Error('Invalid authorization key.');
                }
                // Decorate error with some extra information
                err_1.message = err_1.message + ". Response from server: \"" + err_1.response.data + "\"";
                throw err_1;
            case 4:
                // If it responds with an html page - it means the sheet is private
                if (response.status === 200 &&
                    response.headers['content-type'].indexOf('text/html') >= 0) {
                    throw new Error('Sheet is private. Use authentication or make public. (see https://github.com/theoephraim/node-google-spreadsheet#a-note-on-authentication for details)');
                }
                if (!response.data) return [3 /*break*/, 6];
                promisifedParse = util.promisify(xmlParser.parseString);
                return [4 /*yield*/, promisifedParse(response.data)];
            case 5:
                parseResult = _a.sent();
                return [2 /*return*/, { data: parseResult, xml: response.data }];
            case 6: 
            // No errors and no response. Return empty object here.
            //todo remove?
            return [2 /*return*/, { data: null, xml: null }];
        }
    });
}); };
//# sourceMappingURL=utils.js.map