"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var mocha_1 = require("mocha");
var service_account_creds_json_1 = __importDefault(require("../service-account-creds.json"));
var config_1 = __importDefault(require("../config"));
var lodash_1 = __importDefault(require("lodash"));
var path_1 = __importDefault(require("path"));
var chai_1 = require("chai");
var chai = __importStar(require("chai"));
var chai_as_promised_1 = __importDefault(require("chai-as-promised"));
var GoogleSpreadsheet_1 = require("../../src/old/GoogleSpreadsheet");
chai.use(chai_as_promised_1.default);
chai_1.should();
var docs = {};
Object.keys(config_1.default).forEach(function (key) {
    docs[key] = new GoogleSpreadsheet_1.GoogleSpreadsheet(config_1.default[key]);
});
mocha_1.describe('Authentication', function () {
    var _this = this;
    this.timeout(5000);
    mocha_1.describe('without auth', function () {
        mocha_1.describe('reading + getInfo', function () {
            mocha_1.it('getInfo should fail on a private doc', function () { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, chai_1.expect(docs['private'].getInfo()).to.be.rejectedWith('Sheet is private. Use authentication or make public.')];
                });
            }); });
            mocha_1.it('should fail on a private doc', function () { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, chai_1.expect(docs['private'].getRows(1)).to.be.rejectedWith('Sheet is private. Use authentication or make public.')];
                });
            }); });
            lodash_1.default.each(['public', 'public-read-only'], function (key) {
                mocha_1.it('reading should succeed on a ' + key + ' doc', function () { return __awaiter(_this, void 0, void 0, function () {
                    var rows;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, docs[key].getRows(1)];
                            case 1:
                                rows = _a.sent();
                                rows.should.be.an('array');
                                return [2 /*return*/];
                        }
                    });
                }); });
                mocha_1.it('getInfo should succeed on a ' + key + ' doc', function () { return __awaiter(_this, void 0, void 0, function () {
                    var info;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, docs[key].getInfo()];
                            case 1:
                                info = _a.sent();
                                info.title.should.be.a('string');
                                return [2 /*return*/];
                        }
                    });
                }); });
            });
        });
        mocha_1.describe('writing', function () {
            // it still fails on the public doc because you always need to auth
            lodash_1.default.each(['public', 'public-read-only', 'private'], function (key) {
                mocha_1.it('should fail on a ' + key + ' doc', function () { return __awaiter(_this, void 0, void 0, function () {
                    var err_1;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                _a.trys.push([0, 2, , 3]);
                                return [4 /*yield*/, docs[key].addWorksheet()];
                            case 1:
                                _a.sent();
                                chai_1.assert.isTrue(false, 'should throw');
                                return [3 /*break*/, 3];
                            case 2:
                                err_1 = _a.sent();
                                err_1.should.be.an('Error');
                                err_1.message.should.include('authenticate');
                                return [3 /*break*/, 3];
                            case 3: return [2 /*return*/];
                        }
                    });
                }); });
            });
        });
    });
    mocha_1.describe('authentication', function () {
        mocha_1.it('should fail if the token is empty', function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, chai_1.expect(docs['private'].useServiceAccountAuth({})).to.be
                        .rejected];
            });
        }); });
        mocha_1.it('should fail if the key is no good', function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, chai_1.expect(docs['private'].useServiceAccountAuth({
                        client_email: 'test@example.com',
                        private_key: 'not-a-real-key',
                    })).to.be.rejected];
            });
        }); });
        mocha_1.it('should fail if the email and key do not match', function () { return __awaiter(_this, void 0, void 0, function () {
            var bad_creds;
            return __generator(this, function (_a) {
                bad_creds = lodash_1.default.clone(service_account_creds_json_1.default);
                bad_creds.client_email = 'a' + bad_creds.client_email;
                return [2 /*return*/, chai_1.expect(docs['private'].useServiceAccountAuth(bad_creds)).to.be
                        .rejected];
            });
        }); });
        mocha_1.it('should succeed if the creds are valid', function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, docs['private'].useServiceAccountAuth(service_account_creds_json_1.default)];
            });
        }); });
        mocha_1.it('should accept a string which is a path to the file', function () { return __awaiter(_this, void 0, void 0, function () {
            var creds_file_path;
            return __generator(this, function (_a) {
                creds_file_path = path_1.default.resolve(__dirname + '/../service-account-creds.json');
                return [2 /*return*/, docs['private'].useServiceAccountAuth(creds_file_path)];
            });
        }); });
        mocha_1.it('should fail if the path is invalid', function () { return __awaiter(_this, void 0, void 0, function () {
            var creds_file_path;
            return __generator(this, function (_a) {
                creds_file_path = path_1.default.resolve(__dirname + '/doesnt-exist.json');
                return [2 /*return*/, chai_1.expect(docs['private'].useServiceAccountAuth(creds_file_path)).to
                        .be.rejected];
            });
        }); });
    });
});
mocha_1.describe('with auth', function () {
    var _this = this;
    this.timeout(5000);
    mocha_1.before(function () { return __awaiter(_this, void 0, void 0, function () {
        var _i, _a, doc;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _i = 0, _a = Object.values(docs);
                    _b.label = 1;
                case 1:
                    if (!(_i < _a.length)) return [3 /*break*/, 4];
                    doc = _a[_i];
                    return [4 /*yield*/, doc.useServiceAccountAuth(service_account_creds_json_1.default)];
                case 2:
                    _b.sent();
                    _b.label = 3;
                case 3:
                    _i++;
                    return [3 /*break*/, 1];
                case 4: return [2 /*return*/];
            }
        });
    }); });
    lodash_1.default.each(['public', 'public-read-only', 'private'], function (key) {
        mocha_1.it('getInfo should succeed on a ' + key + ' doc', function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, docs[key].getInfo()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('reading data succeed on a ' + key + ' doc', function () { return __awaiter(_this, void 0, void 0, function () {
            var rows;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, docs[key].getRows(1)];
                    case 1:
                        rows = _a.sent();
                        rows.should.be.an('array');
                        return [2 /*return*/];
                }
            });
        }); });
    });
    lodash_1.default.each(['public', 'private'], function (key) {
        mocha_1.it('writing should succeed on a ' + key + ' doc', function () { return __awaiter(_this, void 0, void 0, function () {
            var sheet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, docs[key].addWorksheet()];
                    case 1:
                        sheet = _a.sent();
                        return [2 /*return*/, sheet.del()];
                }
            });
        }); });
    });
    mocha_1.it('writing should fail if user does not have access', function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, chai_1.expect(docs['public-read-only'].addWorksheet()).to.be.rejectedWith('Request failed with status code 403')];
        });
    }); });
});
//# sourceMappingURL=auth-test.js.map