"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var mocha_1 = require("mocha");
var service_account_creds_json_1 = __importDefault(require("../service-account-creds.json"));
var config_1 = __importDefault(require("../config"));
var chai_1 = __importStar(require("chai"));
var GoogleSpreadsheet_1 = require("../../src/old/GoogleSpreadsheet");
var chai_as_promised_1 = __importDefault(require("chai-as-promised"));
chai_1.default.use(chai_as_promised_1.default);
chai_1.should();
var docs = {};
Object.keys(config_1.default).forEach(function (key) {
    docs[key] = new GoogleSpreadsheet_1.GoogleSpreadsheet(config_1.default[key]);
});
var doc = docs['private'];
var sheet;
var NUM_ROWS = 10;
var NUM_COLS = 10;
mocha_1.describe('Cell-based feeds', function () {
    var _this = this;
    this.timeout(5000);
    mocha_1.before(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, doc.useServiceAccountAuth(service_account_creds_json_1.default)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, doc.addWorksheet({
                            rowCount: NUM_ROWS,
                            colCount: NUM_COLS,
                        })];
                case 2:
                    sheet = _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    mocha_1.after(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, sheet.del()];
        });
    }); });
    mocha_1.describe('getCells params', function () {
        mocha_1.it('fetches an empty array if sheet is empty', function () { return __awaiter(_this, void 0, void 0, function () {
            var cells;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.getCells({})];
                    case 1:
                        cells = _a.sent();
                        cells.length.should.equal(0);
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('fetches entire sheet if `return-empty` is true', function () { return __awaiter(_this, void 0, void 0, function () {
            var cells;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.getCells({ 'return-empty': true })];
                    case 1:
                        cells = _a.sent();
                        cells.length.should.equal(NUM_ROWS * NUM_COLS);
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('respects `min-row`', function () { return __awaiter(_this, void 0, void 0, function () {
            var cells;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.getCells({
                            'return-empty': true,
                            'min-row': 2,
                        })];
                    case 1:
                        cells = _a.sent();
                        cells.length.should.equal((NUM_ROWS - 2 + 1) * NUM_COLS);
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('respects `max-row`', function () { return __awaiter(_this, void 0, void 0, function () {
            var cells;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.getCells({
                            'return-empty': true,
                            'max-row': 5,
                        })];
                    case 1:
                        cells = _a.sent();
                        cells.length.should.equal(5 * NUM_COLS);
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('respects `min-col`', function () { return __awaiter(_this, void 0, void 0, function () {
            var cells;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.getCells({
                            'return-empty': true,
                            'min-col': 2,
                        })];
                    case 1:
                        cells = _a.sent();
                        cells.length.should.equal((NUM_COLS - 2 + 1) * NUM_ROWS);
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('respects `max-col`', function () { return __awaiter(_this, void 0, void 0, function () {
            var cells;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.getCells({
                            'return-empty': true,
                            'max-col': 5,
                        })];
                    case 1:
                        cells = _a.sent();
                        cells.length.should.equal(5 * NUM_ROWS);
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('respects combined min/max params', function () { return __awaiter(_this, void 0, void 0, function () {
            var cells;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.getCells({
                            'return-empty': true,
                            'min-row': 2,
                            'max-row': 4,
                            'min-col': 5,
                            'max-col': 8,
                        })];
                    case 1:
                        cells = _a.sent();
                        cells.length.should.equal((4 - 2 + 1) * (8 - 5 + 1));
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('handles requests outisde the bounds of the sheet', function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, chai_1.expect(sheet.getCells({
                        'return-empty': true,
                        'max-row': 1,
                        'max-col': NUM_COLS + 1,
                    })).to.be.rejectedWith('max-col')];
            });
        }); });
    });
    mocha_1.describe('manipulating cell data', function () {
        var cell;
        mocha_1.before(function () { return __awaiter(_this, void 0, void 0, function () {
            var cells;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.getCells({
                            'return-empty': true,
                        })];
                    case 1:
                        cells = _a.sent();
                        cell = cells[0];
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('has row and column numbers', function () { return __awaiter(_this, void 0, void 0, function () {
            var cells;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.getCells({})];
                    case 1:
                        cells = _a.sent();
                        cell.row.should.equal(1);
                        cell.col.should.equal(1);
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('can update a single cell by calling `setValue`', function () { return __awaiter(_this, void 0, void 0, function () {
            var cells;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, cell.setValue('HELLO')];
                    case 1:
                        _a.sent();
                        cell.value.should.equal('HELLO');
                        return [4 /*yield*/, sheet.getCells({})];
                    case 2:
                        cells = _a.sent();
                        cells[0].value.should.equal('HELLO');
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('can update a single cell by `save`', function () { return __awaiter(_this, void 0, void 0, function () {
            var cells;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cell.value = 'GOODBYE';
                        return [4 /*yield*/, cell.save()];
                    case 1:
                        _a.sent();
                        cell.value.should.equal('GOODBYE');
                        return [4 /*yield*/, sheet.getCells({})];
                    case 2:
                        cells = _a.sent();
                        cells[0].value.should.equal('GOODBYE');
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('supports `value` to numeric values', function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cell.val(123);
                        cell.value.should.equal('123');
                        cell.numericValue.should.equal(123);
                        (cell.formula === undefined).should.be.true;
                        return [4 /*yield*/, cell.save()];
                    case 1:
                        _a.sent();
                        cell.value.should.equal('123');
                        cell.numericValue.should.equal(123);
                        (cell.formula === undefined).should.be.true;
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('supports setting via val()', function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cell.value = '450';
                        cell.val(456);
                        cell.value.should.equal('456');
                        cell.numericValue.should.equal(456);
                        (cell.formula === undefined).should.be.true;
                        return [4 /*yield*/, cell.save()];
                    case 1:
                        _a.sent();
                        cell.value.should.equal('456');
                        cell.numericValue.should.equal(456);
                        (cell.formula === undefined).should.be.true;
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('supports non-numeric values', function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cell.value = 'ABC';
                        cell.value.should.equal('ABC');
                        return [4 /*yield*/, chai_1.expect(function () { return cell.numericValue; }).to.throw('Attempted to get numeric value of a non-numeric')];
                    case 1:
                        _a.sent();
                        (cell.formula === undefined).should.be.true;
                        return [4 /*yield*/, cell.save()];
                    case 2:
                        _a.sent();
                        cell.value.should.equal('ABC');
                        return [4 /*yield*/, chai_1.expect(function () { return cell.numericValue; }).to.throw('Attempted to get numeric value of a non-numeric')];
                    case 3:
                        _a.sent();
                        (cell.formula === undefined).should.be.true;
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('throws an error if setting an invalid formula', function () {
            var err;
            try {
                cell.formula = 'This is not a formula';
            }
            catch (_err) {
                err = _err;
            }
            err.should.be.an('Error');
        });
        mocha_1.it('supports formulas that resolve to a numeric value', function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cell.formula = '=ROW()';
                        return [4 /*yield*/, chai_1.expect(function () { return cell.numericValue; }).to.throw('Attempted to get numeric value of a non-numeric')];
                    case 1:
                        _a.sent();
                        cell.value.should.equal('*SAVE TO GET NEW VALUE*');
                        cell.formula.should.equal('=ROW()');
                        return [4 /*yield*/, cell.save()];
                    case 2:
                        _a.sent();
                        cell.value.should.equal('1');
                        cell.numericValue.should.equal(1);
                        cell.formula.should.equal('=ROW()');
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('persists the new formula value', function () { return __awaiter(_this, void 0, void 0, function () {
            var cells;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.getCells({})];
                    case 1:
                        cells = _a.sent();
                        cells[0].value.should.equal('1');
                        cells[0].numericValue.should.equal(1);
                        cells[0].formula.should.equal('=ROW()');
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('supports formulas that resolve to non-numeric values', function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cell.formula = '=IF(TRUE, "ABC", "DEF")';
                        return [4 /*yield*/, cell.save()];
                    case 1:
                        _a.sent();
                        cell.value.should.equal('ABC');
                        return [4 /*yield*/, chai_1.expect(function () { return cell.numericValue; }).to.throw('Attempted to get numeric value of a non-numeric')];
                    case 2:
                        _a.sent();
                        cell.formula.should.equal('=IF(TRUE, "ABC", "DEF")');
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('supports setting the formula via the `value` property', function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cell.value = '=COLUMN()';
                        cell.value.should.equal('*SAVE TO GET NEW VALUE*');
                        cell.formula.should.equal('=COLUMN()');
                        return [4 /*yield*/, chai_1.expect(function () { return cell.numericValue; }).to.throw('Attempted to get numeric value of a non-numeric')];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, cell.save()];
                    case 2:
                        _a.sent();
                        cell.value.should.equal('1');
                        cell.numericValue.should.equal(1);
                        cell.formula.should.equal('=COLUMN()');
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('supports clearing the `value`', function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cell.value = '4';
                        cell.value = '';
                        cell.value.should.equal('');
                        return [4 /*yield*/, chai_1.expect(function () { return cell.numericValue; }).to.throw('Attempted to get numeric value of a non-numeric')];
                    case 1:
                        _a.sent();
                        (cell.formula === undefined).should.be.true;
                        return [4 /*yield*/, cell.save()];
                    case 2:
                        _a.sent();
                        cell.value.should.equal('');
                        return [4 /*yield*/, chai_1.expect(function () { return cell.numericValue; }).to.throw('Attempted to get numeric value of a non-numeric')];
                    case 3:
                        _a.sent();
                        (cell.formula === undefined).should.be.true;
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('can update a single cell with linefeed in value', function () { return __awaiter(_this, void 0, void 0, function () {
            var cells;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, cell.setValue('HELLO\nWORLD')];
                    case 1:
                        _a.sent();
                        cell.value.should.equal('HELLO\nWORLD');
                        return [4 /*yield*/, sheet.getCells({})];
                    case 2:
                        cells = _a.sent();
                        cells[0].value.should.equal('HELLO\nWORLD');
                        return [2 /*return*/];
                }
            });
        }); });
    });
    mocha_1.describe('bulk cell updates', function () {
        var cells;
        mocha_1.before(function () { return __awaiter(_this, void 0, void 0, function () {
            var _cells;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.getCells({
                            'return-empty': true,
                        })];
                    case 1:
                        _cells = _a.sent();
                        cells = _cells.slice(0, 4);
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('succeeds if no cells need an update', function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, sheet.bulkUpdateCells(cells)];
            });
        }); });
        mocha_1.it('can update multiple cells at once', function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cells[0].val(1);
                        cells[1].value = '2';
                        cells[2].formula = '=A1+B1';
                        return [4 /*yield*/, sheet.bulkUpdateCells(cells)];
                    case 1:
                        _a.sent();
                        cells[0].numericValue.should.equal(1);
                        cells[1].numericValue.should.equal(2);
                        cells[2].numericValue.should.equal(3);
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
//# sourceMappingURL=cells-test.js.map