"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var mocha_1 = require("mocha");
var service_account_creds_json_1 = __importDefault(require("../service-account-creds.json"));
var config_1 = __importDefault(require("../config"));
var lodash_1 = __importDefault(require("lodash"));
var chai_1 = require("chai");
var GoogleSpreadsheet_1 = require("../../src/old/GoogleSpreadsheet");
chai_1.should();
var docs = {};
Object.keys(config_1.default).forEach(function (key) {
    docs[key] = new GoogleSpreadsheet_1.GoogleSpreadsheet(config_1.default[key]);
});
var doc = docs['private'];
mocha_1.describe('Managing doc info and sheets', function () {
    var _this = this;
    this.timeout(5000);
    mocha_1.before(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, doc.useServiceAccountAuth(service_account_creds_json_1.default)];
        });
    }); });
    mocha_1.describe('get doc info', function () {
        var info;
        mocha_1.it('can fetch the doc info', function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, doc.getInfo()];
                    case 1:
                        info = _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('should have the doc id', function () {
            info.id.should.equal('https://spreadsheets.google.com/feeds/worksheets/' +
                config_1.default['private'] +
                '/private/full');
        });
        mocha_1.it('should include the document title', function () {
            info.title.should.be.a('string'); //todo changed
        });
        mocha_1.it('should include author metadata', function () {
            info.author.name.should.equal('theozero');
            info.author.email.should.equal('theozero@gmail.com');
        });
        mocha_1.it('should include updated timestamp', function () {
            info.updated.should.match(/\d\d\d\d-\d\d-\d\dT\d\d:\d\d:\d\d\.\d\d\dZ/);
            new Date(info.updated).should.be.a('Date');
        });
        mocha_1.it('should include worksheets', function () {
            info.worksheets.should.have.length.above(0);
            var sheet = info.worksheets[0];
            sheet.url.should.include(config_1.default['private']);
            sheet.title.should.be.a('string');
            sheet.rowCount.should.be.a('number');
            sheet.colCount.should.be.a('number');
        });
    });
    mocha_1.describe('adding, removing, and modifying worksheets', function () {
        var sheet_title = 'Test sheet ' + +new Date();
        var sheet;
        var sheets_to_remove = [];
        mocha_1.after(function () { return __awaiter(_this, void 0, void 0, function () {
            var _i, sheets_to_remove_1, sheet_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _i = 0, sheets_to_remove_1 = sheets_to_remove;
                        _a.label = 1;
                    case 1:
                        if (!(_i < sheets_to_remove_1.length)) return [3 /*break*/, 4];
                        sheet_1 = sheets_to_remove_1[_i];
                        return [4 /*yield*/, sheet_1.del()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('can add a worksheet', function () { return __awaiter(_this, void 0, void 0, function () {
            var info, added_sheet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, doc.addWorksheet({
                            title: sheet_title,
                            colCount: 10,
                        })];
                    case 1:
                        sheet = _a.sent();
                        sheet.title.should.equal(sheet_title);
                        return [4 /*yield*/, doc.getInfo()];
                    case 2:
                        info = _a.sent();
                        added_sheet = info.worksheets.pop();
                        added_sheet.title.should.equal(sheet_title);
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('can set the header row of a worksheet', function () { return __awaiter(_this, void 0, void 0, function () {
            var header_vals, cells;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        header_vals = ['x1', 'x2', 'x3', 'x4', 'x5'];
                        return [4 /*yield*/, sheet.setHeaderRow(header_vals)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, sheet.getCells()];
                    case 2:
                        cells = _a.sent();
                        cells.length.should.equal(5);
                        lodash_1.default.times(header_vals.length, function (i) {
                            cells[i].value.should.equal(header_vals[i]);
                        });
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('clears the rest of the header row when setting headers', function () { return __awaiter(_this, void 0, void 0, function () {
            var header_vals, cells;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        header_vals = ['x1', 'x2'];
                        return [4 /*yield*/, sheet.setHeaderRow(header_vals)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, sheet.getCells()];
                    case 2:
                        cells = _a.sent();
                        // only returns cells with values in them
                        cells.length.should.equal(2);
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('can clear a worksheet', function () { return __awaiter(_this, void 0, void 0, function () {
            var cells;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.clear()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, sheet.getCells()];
                    case 2:
                        cells = _a.sent();
                        // only returns cells with values in them
                        cells.length.should.equal(0);
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('can resize a worksheet', function () { return __awaiter(_this, void 0, void 0, function () {
            var info, last_sheet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.resize({ rowCount: 5, colCount: 7 })];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, doc.getInfo()];
                    case 2:
                        info = _a.sent();
                        last_sheet = info.worksheets.pop();
                        last_sheet.rowCount.should.equal(5);
                        last_sheet.colCount.should.equal(7);
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('can set the title of a worksheet', function () { return __awaiter(_this, void 0, void 0, function () {
            var new_title, info, last_sheet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        new_title = 'New title ' + +new Date();
                        return [4 /*yield*/, sheet.setTitle(new_title)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, doc.getInfo()];
                    case 2:
                        info = _a.sent();
                        last_sheet = info.worksheets.pop();
                        last_sheet.title.should.equal(new_title);
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('can delete a worksheet with `SpreadsheetWorksheet.del()`', function () { return __awaiter(_this, void 0, void 0, function () {
            var info, last_sheet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.del()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, doc.getInfo()];
                    case 2:
                        info = _a.sent();
                        last_sheet = info.worksheets.pop();
                        last_sheet.title.should.not.equal(sheet_title);
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('can delete a worksheet with `GoogleSpreadsheet.removeWorksheet()` passing the sheet object', function () { return __awaiter(_this, void 0, void 0, function () {
            var newSheet, info, last_sheet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, doc.addWorksheet({
                            title: sheet_title,
                            colCount: 10,
                        })];
                    case 1:
                        newSheet = _a.sent();
                        return [4 /*yield*/, doc.removeWorksheet(newSheet)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, doc.getInfo()];
                    case 3:
                        info = _a.sent();
                        last_sheet = info.worksheets.pop();
                        last_sheet.title.should.not.equal(sheet_title);
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('can delete a worksheet with `GoogleSpreadsheet.removeWorksheet()` passing the sheet ID', function () { return __awaiter(_this, void 0, void 0, function () {
            var newSheet, info, last_sheet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, doc.addWorksheet({
                            title: sheet_title,
                            colCount: 10,
                        })];
                    case 1:
                        newSheet = _a.sent();
                        return [4 /*yield*/, doc.removeWorksheet(newSheet.id)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, doc.getInfo()];
                    case 3:
                        info = _a.sent();
                        last_sheet = info.worksheets.pop();
                        last_sheet.title.should.not.equal(sheet_title);
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('can delete a worksheet with `GoogleSpreadsheet.removeWorksheet()` passing the index of the sheet', function () { return __awaiter(_this, void 0, void 0, function () {
            var info, sheet_index, newInfo, last_sheet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, doc.addWorksheet({
                            title: sheet_title,
                            colCount: 10,
                        })];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, doc.getInfo()];
                    case 2:
                        info = _a.sent();
                        sheet_index = info.worksheets.length;
                        return [4 /*yield*/, doc.removeWorksheet(sheet_index)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, doc.getInfo()];
                    case 4:
                        newInfo = _a.sent();
                        last_sheet = newInfo.worksheets.pop();
                        last_sheet.title.should.not.equal(sheet_title);
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('can add a sheet with specific number of rows and columns', function () { return __awaiter(_this, void 0, void 0, function () {
            var sheet, info, new_sheet;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, doc.addWorksheet({
                            title: sheet_title,
                            rowCount: 17,
                            colCount: 13,
                        })];
                    case 1:
                        sheet = _a.sent();
                        sheets_to_remove.push(sheet);
                        return [4 /*yield*/, doc.getInfo()];
                    case 2:
                        info = _a.sent();
                        new_sheet = info.worksheets.pop();
                        new_sheet.rowCount.should.equal(17);
                        new_sheet.colCount.should.equal(13);
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('can specify column headers while adding a sheet', function () { return __awaiter(_this, void 0, void 0, function () {
            var sheet, cells;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, doc.addWorksheet({
                            headers: ['header1', 'header2', 'header3'],
                        })];
                    case 1:
                        sheet = _a.sent();
                        sheets_to_remove.push(sheet);
                        return [4 /*yield*/, sheet.getCells()];
                    case 2:
                        cells = _a.sent();
                        cells.length.should.equal(3);
                        cells[0].value.should.equal('header1');
                        cells[1].value.should.equal('header2');
                        cells[2].value.should.equal('header3');
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
//# sourceMappingURL=manage-test.js.map