"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var mocha_1 = require("mocha");
var service_account_creds_json_1 = __importDefault(require("../service-account-creds.json"));
var config_1 = __importDefault(require("../config"));
var lodash_1 = __importDefault(require("lodash"));
var chai_1 = require("chai");
var GoogleSpreadsheet_1 = require("../../src/old/GoogleSpreadsheet");
chai_1.should();
var docs = {};
Object.keys(config_1.default).forEach(function (key) {
    docs[key] = new GoogleSpreadsheet_1.GoogleSpreadsheet(config_1.default[key]);
});
var doc = docs['private'];
var sheet;
var MAX_NUM = 5;
var NUMBERS = lodash_1.default.times(MAX_NUM);
var LETTERS = ['C', 'D', 'E', 'A', 'B'];
mocha_1.describe('Row-based feeds', function () {
    var _this = this;
    this.timeout(5000);
    mocha_1.before(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, doc.useServiceAccountAuth(service_account_creds_json_1.default)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, doc.addWorksheet({
                            headers: ['col1', 'col2', 'col3'],
                        })];
                case 2:
                    sheet = _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    mocha_1.after(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, sheet.del()];
        });
    }); });
    mocha_1.describe('adding, updating, removing rows', function () {
        var row;
        mocha_1.it('can add a row', function () { return __awaiter(_this, void 0, void 0, function () {
            var new_data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        new_data = {
                            col1: 'c1',
                            col2: 'c2',
                            col3: 'c3',
                        };
                        return [4 /*yield*/, sheet.addRow(new_data)];
                    case 1:
                        row = _a.sent();
                        row.col1.should.equal(new_data.col1);
                        row.col2.should.equal(new_data.col2);
                        row.col3.should.equal(new_data.col3);
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('can update a row', function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                row.col1 = 'col1-update';
                row.col2 = 'col2-update';
                return [2 /*return*/, row.save()];
            });
        }); });
        mocha_1.it('persisted the row update', function () { return __awaiter(_this, void 0, void 0, function () {
            var rows;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.getRows()];
                    case 1:
                        rows = _a.sent();
                        rows.length.should.equal(1);
                        rows[0].col1.should.equal(row.col1);
                        rows[0].col2.should.equal(row.col2);
                        rows[0].col3.should.equal(row.col3);
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('can write a formula', function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                row.col1 = 1;
                row.col2 = 2;
                row.col3 = '=A2+B2';
                return [2 /*return*/, row.save()];
            });
        }); });
        mocha_1.it('can read (only) the value from a formula', function () { return __awaiter(_this, void 0, void 0, function () {
            var rows;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.getRows()];
                    case 1:
                        rows = _a.sent();
                        rows[0].col3.should.equal('3');
                        return [2 /*return*/];
                }
            });
        }); });
        lodash_1.default.each({
            'new lines': 'new\n\nlines\n',
            'special chars': '∑πécial <> chårs = !\t',
        }, function (value, description) {
            mocha_1.it('supports ' + description, function () { return __awaiter(_this, void 0, void 0, function () {
                var rows;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            row.col1 = value;
                            return [4 /*yield*/, row.save()];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, sheet.getRows()];
                        case 2:
                            rows = _a.sent();
                            rows.length.should.equal(1);
                            rows[0].col1.should.equal(value);
                            return [2 /*return*/];
                    }
                });
            }); });
        });
        mocha_1.it('can delete a row', function () { return __awaiter(_this, void 0, void 0, function () {
            var rows;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, row.del()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, sheet.getRows()];
                    case 2:
                        rows = _a.sent();
                        rows.length.should.equal(0);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    mocha_1.describe('fetching rows', function () {
        var _this = this;
        // add 5 rows to use for read tests
        mocha_1.before(function () { return __awaiter(_this, void 0, void 0, function () {
            var _i, NUMBERS_1, i;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.timeout(5000);
                        _i = 0, NUMBERS_1 = NUMBERS;
                        _a.label = 1;
                    case 1:
                        if (!(_i < NUMBERS_1.length)) return [3 /*break*/, 4];
                        i = NUMBERS_1[_i];
                        return [4 /*yield*/, sheet.addRow({
                                col1: i,
                                col2: LETTERS[i],
                                col3: new Date().toISOString(),
                            })];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('can fetch multiple rows', function () { return __awaiter(_this, void 0, void 0, function () {
            var rows;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.getRows()];
                    case 1:
                        rows = _a.sent();
                        rows.length.should.equal(5);
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('supports `offset` option', function () { return __awaiter(_this, void 0, void 0, function () {
            var rows;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.getRows({ offset: 3 })];
                    case 1:
                        rows = _a.sent();
                        rows.length.should.equal(MAX_NUM - 3 + 1); //offset is inclusive
                        rows[0].col1.should.equal('2');
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('supports `limit` option', function () { return __awaiter(_this, void 0, void 0, function () {
            var rows;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.getRows({ limit: 3 })];
                    case 1:
                        rows = _a.sent();
                        rows.length.should.equal(3);
                        rows[0].col1.should.equal('0');
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('supports `orderby` option', function () { return __awaiter(_this, void 0, void 0, function () {
            var rows;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.getRows({ orderby: 'col2' })];
                    case 1:
                        rows = _a.sent();
                        rows.length.should.equal(5);
                        lodash_1.default.map(rows, 'col2').should.deep.equal(lodash_1.default.sortBy(LETTERS));
                        return [2 /*return*/];
                }
            });
        }); });
        // GOOGLE HAS A KNOWN BUG WITH THIS!
        // see: http://stackoverflow.com/questions/32272783/google-sheets-api-reverse-order-parameter-ignored/34805432#34805432
        mocha_1.it.skip('supports `reverse` option', function () { return __awaiter(_this, void 0, void 0, function () {
            var rows;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.getRows({ reverse: true })];
                    case 1:
                        rows = _a.sent();
                        rows.length.should.equal(5);
                        rows[0].col1.should.equal('4');
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('supports `query` option', function () { return __awaiter(_this, void 0, void 0, function () {
            var rows;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.getRows({ query: 'col1>=2 and col1<4' })];
                    case 1:
                        rows = _a.sent();
                        rows.length.should.equal(2);
                        lodash_1.default.map(rows, 'col1').should.include.members(['2', '3']);
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('supports `orderby`+`reverse` option', function () { return __awaiter(_this, void 0, void 0, function () {
            var rows;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.getRows({ orderby: 'col2', reverse: true })];
                    case 1:
                        rows = _a.sent();
                        rows.length.should.equal(5);
                        lodash_1.default.map(rows, 'col2').should.deep.equal(lodash_1.default.sortBy(LETTERS).reverse());
                        return [2 /*return*/];
                }
            });
        }); });
        mocha_1.it('supports `orderby`+`limit` option', function () { return __awaiter(_this, void 0, void 0, function () {
            var rows;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sheet.getRows({ orderby: 'col2', limit: 2 })];
                    case 1:
                        rows = _a.sent();
                        rows.length.should.equal(2);
                        lodash_1.default.map(rows, 'col2').should.deep.equal(lodash_1.default.sortBy(LETTERS).slice(0, 2));
                        return [2 /*return*/];
                }
            });
        }); });
        // we could add more tests here, but it seems a bit unnecessary
        // as it would just be testing google's API
    });
});
//# sourceMappingURL=rows-test.js.map